/* --COPYRIGHT--,BSD
 * Copyright (c) 2014, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ti.msp.gui.main;

import com.ti.msp.common.Splash;
import com.ti.msp.common.StaticInfo;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.UnsupportedLookAndFeelException;

public class Main {
    public static String userHome = System.getProperty("user.home");;
    public static String fileSeparator = System.getProperty("file.separator");
    public static String APLICATION_NAME = "MSP\u2122 BSL Encryptor";
    public static String APLICATION_VERSION = "1.00.00.04";

   
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        // Init Log file
        File logDir = new File("log");
        File log = new File("log/logFile.txt");
        logDir.mkdirs();
        if(logDir.exists()==false){
            try {
                log.createNewFile();
            } catch (IOException ex) {
                Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        StaticInfo.initLogFile(log.getAbsolutePath());
        StaticInfo.setDebug(5);
        StaticInfo.debug("OS:" + System.getProperty("os.name").toLowerCase());
        StaticInfo.debug("Java Info:" + System.getProperty("java.version") + " "+ System.getProperty("os.arch").toLowerCase());
        
        
        for (javax.swing.UIManager.LookAndFeelInfo info : 
                    javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    try {
          
                            javax.swing.UIManager.setLookAndFeel(info.getClassName());
                        
                        
                        break;
                    } catch (UnsupportedLookAndFeelException ex) {
                        StaticInfo.debug(ex.getMessage());
                    } catch (ClassNotFoundException ex) {
                        StaticInfo.debug(ex.getMessage());
                    } catch (InstantiationException ex) {
                        StaticInfo.debug(ex.getMessage());
                    } catch (IllegalAccessException ex) {
                        StaticInfo.debug(ex.getMessage());
                    }
               
                }
            }
        

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                Splash splash = new Splash();
                splash.show();
                MainFrame tool = new MainFrame();
                tool.setVisible(true);
            }
        });
    }
    
}
