/* --COPYRIGHT--,BSD
 * Copyright (c) 2014, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ti.msp.gui.main;

import com.ti.msp.common.StaticInfo;
import com.ti.msp.gui.help.HelpDialog;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.util.List;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.awt.Color;
import java.util.Arrays;

import org.bouncycastle.crypto.InvalidCipherTextException;
import org.bouncycastle.util.encoders.Hex;
import org.bouncycastle.crypto.modes.CCMBlockCipher;
import org.bouncycastle.crypto.params.KeyParameter;
import org.bouncycastle.crypto.engines.AESFastEngine;
import org.bouncycastle.crypto.params.CCMParameters;



/**
 *
 * @author a0272979
 */
public class MainFrame extends javax.swing.JFrame  {
    
    File prevDir = null;
    String TITXTfileName = "";
    boolean TITXTenabled = false;
    KeyIV Dkey = new KeyIV();
    KeyIV NewKey = new KeyIV();
    KeyIV KEKKey = new KeyIV();
    String StatusText = "";
    
    String flags = "01";
    String counter = "00 00";
    String reserved = "0000";
    int packetsize = 214;
    
    /**
     * Creates new form DescriptorTool
     */
    public MainFrame() {
        initComponents();
        Update_GUIComponents();
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jMenuItem5 = new javax.swing.JMenuItem();
        ButtonGroup_UpdateFW = new javax.swing.ButtonGroup();
        ButtonGroup_UpdateKEK = new javax.swing.ButtonGroup();
        ButtonGroup_NewKey = new javax.swing.ButtonGroup();
        TabbedPanel = new javax.swing.JTabbedPane();
        Panel_EncryptFile = new javax.swing.JPanel();
        TITXT = new javax.swing.JLabel();
        TextField_TITXTfile = new javax.swing.JTextField();
        Button_SearchTITXT = new javax.swing.JButton();
        RadioButton_KeyFile = new javax.swing.JRadioButton();
        TextField_Keyfile = new javax.swing.JTextField();
        Button_SearchKey = new javax.swing.JButton();
        RadioButton_KeyButton = new javax.swing.JRadioButton();
        TextField_Key = new javax.swing.JTextField();
        FWKeyNonce = new javax.swing.JLabel();
        TextField_FWNonce = new javax.swing.JTextField();
        CheckBox_GenFile = new javax.swing.JCheckBox();
        CheckBox_SaveKey = new javax.swing.JCheckBox();
        TITXT1 = new javax.swing.JLabel();
        Spinner_AppVersion = new javax.swing.JSpinner();
        Panel_KeyUpdate = new javax.swing.JPanel();
        Button_FileNewKey = new javax.swing.JButton();
        Button_FileKEK = new javax.swing.JButton();
        TextField_KEKFile = new javax.swing.JTextField();
        TextField_KEK = new javax.swing.JTextField();
        Text_Field_KEKNonce = new javax.swing.JTextField();
        TextField_NewKeyFile = new javax.swing.JTextField();
        RadioButton_KEKFile = new javax.swing.JRadioButton();
        RadioButton_KEK = new javax.swing.JRadioButton();
        KEKNonce = new javax.swing.JLabel();
        TextField_NewKey = new javax.swing.JTextField();
        CheckBox_UpdateKey = new javax.swing.JCheckBox();
        RadioButton_NewKeyFile = new javax.swing.JRadioButton();
        RadioButton_NewKey = new javax.swing.JRadioButton();
        CheckBox_SaveKEKKeys = new javax.swing.JCheckBox();
        CheckBox_SaveNewKey = new javax.swing.JCheckBox();
        ComboBox_NewKeyType = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        TITXT2 = new javax.swing.JLabel();
        Spinner_NewKeyVersion = new javax.swing.JSpinner();
        jPanel1 = new javax.swing.JPanel();
        Button_FWEncrypt = new javax.swing.JButton();
        ScrollPane = new javax.swing.JScrollPane();
        TextArea_Status = new javax.swing.JTextArea();
        messageLabel = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        jMenuItem2 = new javax.swing.JMenuItem();

        jMenuItem5.setText("jMenuItem5");

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle(Main.APLICATION_NAME + " ("+ Main.APLICATION_VERSION +")");
        setIconImage(new ImageIcon("images/tibug.png").getImage());
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        TabbedPanel.setName(""); // NOI18N

        Panel_EncryptFile.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        TITXT.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        TITXT.setText("TI TXT file:");

        TextField_TITXTfile.setEditable(false);
        TextField_TITXTfile.setBackground(new java.awt.Color(255, 255, 255));
        TextField_TITXTfile.setFont(new java.awt.Font("Arial", 0, 14)); // NOI18N
        TextField_TITXTfile.setToolTipText("Select the Input TXT file");
        TextField_TITXTfile.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(255, 0, 0)));

        Button_SearchTITXT.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        Button_SearchTITXT.setText("Browse");
        Button_SearchTITXT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Button_SearchTITXTActionPerformed(evt);
            }
        });

        ButtonGroup_UpdateFW.add(RadioButton_KeyFile);
        RadioButton_KeyFile.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        RadioButton_KeyFile.setText("Key file:");
        RadioButton_KeyFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RadioButton_KeyFileActionPerformed(evt);
            }
        });

        TextField_Keyfile.setEditable(false);
        TextField_Keyfile.setFont(new java.awt.Font("Arial", 0, 14)); // NOI18N
        TextField_Keyfile.setToolTipText("Select the Key File");
        TextField_Keyfile.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
        TextField_Keyfile.setEnabled(false);

        Button_SearchKey.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        Button_SearchKey.setText("Browse");
        Button_SearchKey.setEnabled(false);
        Button_SearchKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Button_SearchKeyActionPerformed(evt);
            }
        });

        ButtonGroup_UpdateFW.add(RadioButton_KeyButton);
        RadioButton_KeyButton.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        RadioButton_KeyButton.setSelected(true);
        RadioButton_KeyButton.setText("Key:");
        RadioButton_KeyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RadioButton_KeyButtonActionPerformed(evt);
            }
        });

        TextField_Key.setFont(new java.awt.Font("Courier New", 0, 14)); // NOI18N
        TextField_Key.setText("00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");
        TextField_Key.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TextField_KeyActionPerformed(evt);
            }
        });

        FWKeyNonce.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        FWKeyNonce.setText("Nonce:");

        TextField_FWNonce.setFont(new java.awt.Font("Courier New", 0, 14)); // NOI18N
        TextField_FWNonce.setText("10 11 12 13 14 15 16 17 18 19 1A 1B 1C");

        CheckBox_GenFile.setSelected(true);
        CheckBox_GenFile.setText("Generate Encrypted File");
        CheckBox_GenFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CheckBox_GenFileActionPerformed(evt);
            }
        });

        CheckBox_SaveKey.setText("Save Key to file");
        CheckBox_SaveKey.setToolTipText("Enable to save key to a file");

        TITXT1.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        TITXT1.setText("Version:");

        Spinner_AppVersion.setModel(new javax.swing.SpinnerNumberModel(0, 0, 255, 1));

        javax.swing.GroupLayout Panel_EncryptFileLayout = new javax.swing.GroupLayout(Panel_EncryptFile);
        Panel_EncryptFile.setLayout(Panel_EncryptFileLayout);
        Panel_EncryptFileLayout.setHorizontalGroup(
            Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(Panel_EncryptFileLayout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(CheckBox_GenFile, javax.swing.GroupLayout.DEFAULT_SIZE, 659, Short.MAX_VALUE)
                    .addGroup(Panel_EncryptFileLayout.createSequentialGroup()
                        .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(Panel_EncryptFileLayout.createSequentialGroup()
                                .addComponent(TITXT1, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Spinner_AppVersion, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(Panel_EncryptFileLayout.createSequentialGroup()
                                .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(RadioButton_KeyFile, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(RadioButton_KeyButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(TITXT, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(Panel_EncryptFileLayout.createSequentialGroup()
                                        .addGap(21, 21, 21)
                                        .addComponent(FWKeyNonce, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                                .addGap(18, 18, 18)
                                .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(TextField_Keyfile, javax.swing.GroupLayout.PREFERRED_SIZE, 408, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(TextField_Key, javax.swing.GroupLayout.PREFERRED_SIZE, 408, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(TextField_FWNonce, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 408, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(TextField_TITXTfile, javax.swing.GroupLayout.PREFERRED_SIZE, 408, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(Button_SearchTITXT)
                                    .addComponent(Button_SearchKey)
                                    .addComponent(CheckBox_SaveKey))))
                        .addGap(12, 12, 12)))
                .addGap(25, 25, 25))
        );
        Panel_EncryptFileLayout.setVerticalGroup(
            Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, Panel_EncryptFileLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(CheckBox_GenFile)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(TITXT)
                        .addComponent(TextField_TITXTfile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(Button_SearchTITXT))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(TITXT1)
                    .addComponent(Spinner_AppVersion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(TextField_Keyfile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Button_SearchKey)
                    .addComponent(RadioButton_KeyFile))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(RadioButton_KeyButton)
                    .addComponent(TextField_Key, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(CheckBox_SaveKey))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(Panel_EncryptFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(FWKeyNonce)
                    .addComponent(TextField_FWNonce, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(45, Short.MAX_VALUE))
        );

        TabbedPanel.addTab("Encrypt File", Panel_EncryptFile);

        Panel_KeyUpdate.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        Button_FileNewKey.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        Button_FileNewKey.setText("Browse");
        Button_FileNewKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Button_FileNewKeyActionPerformed(evt);
            }
        });

        Button_FileKEK.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        Button_FileKEK.setText("Browse");
        Button_FileKEK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Button_FileKEKActionPerformed(evt);
            }
        });

        TextField_KEKFile.setEditable(false);
        TextField_KEKFile.setFont(new java.awt.Font("Arial", 0, 14)); // NOI18N
        TextField_KEKFile.setToolTipText("Select the KEK file");

        TextField_KEK.setFont(new java.awt.Font("Courier New", 0, 14)); // NOI18N
        TextField_KEK.setText("F0 F1 F2 F3 F4 F5 F6 F7 F8 F9 FA FB FC FD FE FF");
        TextField_KEK.setToolTipText("Specify the Key Encryption Key");

        Text_Field_KEKNonce.setFont(new java.awt.Font("Courier New", 0, 14)); // NOI18N
        Text_Field_KEKNonce.setText("E0 E1 E2 E3 E4 E5 E6 E7 E8 E9 EA EB EC");
        Text_Field_KEKNonce.setToolTipText("Write the Nonce");

        TextField_NewKeyFile.setEditable(false);
        TextField_NewKeyFile.setFont(new java.awt.Font("Arial", 0, 14)); // NOI18N
        TextField_NewKeyFile.setToolTipText("Select the New Key File");
        TextField_NewKeyFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TextField_NewKeyFileActionPerformed(evt);
            }
        });

        ButtonGroup_UpdateKEK.add(RadioButton_KEKFile);
        RadioButton_KEKFile.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        RadioButton_KEKFile.setText("KEK file: ");
        RadioButton_KEKFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RadioButton_KEKFileActionPerformed(evt);
            }
        });

        ButtonGroup_UpdateKEK.add(RadioButton_KEK);
        RadioButton_KEK.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        RadioButton_KEK.setSelected(true);
        RadioButton_KEK.setText("KEK:");
        RadioButton_KEK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RadioButton_KEKActionPerformed(evt);
            }
        });

        KEKNonce.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        KEKNonce.setText("      Nonce:");

        TextField_NewKey.setFont(new java.awt.Font("Courier New", 0, 14)); // NOI18N
        TextField_NewKey.setText("00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");
        TextField_NewKey.setToolTipText("Write a New Key");

        CheckBox_UpdateKey.setText("Update Key");
        CheckBox_UpdateKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CheckBox_UpdateKeyActionPerformed(evt);
            }
        });

        ButtonGroup_NewKey.add(RadioButton_NewKeyFile);
        RadioButton_NewKeyFile.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        RadioButton_NewKeyFile.setText("New Key File:");
        RadioButton_NewKeyFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RadioButton_NewKeyFileActionPerformed(evt);
            }
        });

        ButtonGroup_NewKey.add(RadioButton_NewKey);
        RadioButton_NewKey.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        RadioButton_NewKey.setSelected(true);
        RadioButton_NewKey.setText("New Key:");
        RadioButton_NewKey.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RadioButton_NewKeyActionPerformed(evt);
            }
        });

        CheckBox_SaveKEKKeys.setText("Save KEK to file");
        CheckBox_SaveKEKKeys.setToolTipText("Enable to save KEK to a file");

        CheckBox_SaveNewKey.setText("Save New Key to file");
        CheckBox_SaveNewKey.setToolTipText("Enable to Save New key to a file");

        ComboBox_NewKeyType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Data", "KEK", "Reserved" }));

        jLabel1.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        jLabel1.setText("Type:");

        TITXT2.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        TITXT2.setText("Key Version:");

        Spinner_NewKeyVersion.setModel(new javax.swing.SpinnerNumberModel(0, 0, 255, 1));

        javax.swing.GroupLayout Panel_KeyUpdateLayout = new javax.swing.GroupLayout(Panel_KeyUpdate);
        Panel_KeyUpdate.setLayout(Panel_KeyUpdateLayout);
        Panel_KeyUpdateLayout.setHorizontalGroup(
            Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(Panel_KeyUpdateLayout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(CheckBox_UpdateKey, javax.swing.GroupLayout.PREFERRED_SIZE, 659, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(Panel_KeyUpdateLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addComponent(RadioButton_NewKeyFile, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(RadioButton_KEK, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(RadioButton_KEKFile, javax.swing.GroupLayout.DEFAULT_SIZE, 117, Short.MAX_VALUE)
                            .addComponent(KEKNonce, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addComponent(RadioButton_NewKey, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addGroup(Panel_KeyUpdateLayout.createSequentialGroup()
                        .addComponent(TITXT2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(Spinner_NewKeyVersion, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(ComboBox_NewKeyType, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(Text_Field_KEKNonce, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 410, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(TextField_KEK, javax.swing.GroupLayout.PREFERRED_SIZE, 410, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(TextField_KEKFile, javax.swing.GroupLayout.PREFERRED_SIZE, 410, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(TextField_NewKey, javax.swing.GroupLayout.PREFERRED_SIZE, 410, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(TextField_NewKeyFile, javax.swing.GroupLayout.PREFERRED_SIZE, 410, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(Button_FileNewKey, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Button_FileKEK, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(CheckBox_SaveNewKey)
                    .addComponent(CheckBox_SaveKEKKeys, javax.swing.GroupLayout.PREFERRED_SIZE, 125, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(0, 27, Short.MAX_VALUE))
        );
        Panel_KeyUpdateLayout.setVerticalGroup(
            Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(Panel_KeyUpdateLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(Panel_KeyUpdateLayout.createSequentialGroup()
                        .addComponent(CheckBox_UpdateKey)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(RadioButton_NewKeyFile)
                            .addComponent(TextField_NewKeyFile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Button_FileNewKey))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(RadioButton_NewKey)
                            .addComponent(TextField_NewKey, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(CheckBox_SaveNewKey, javax.swing.GroupLayout.Alignment.TRAILING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel1)
                        .addComponent(ComboBox_NewKeyType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(TITXT2)
                        .addComponent(Spinner_NewKeyVersion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, Short.MAX_VALUE)
                .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(RadioButton_KEKFile)
                    .addComponent(TextField_KEKFile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Button_FileKEK))
                .addGap(5, 5, 5)
                .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(TextField_KEK, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(RadioButton_KEK)
                    .addComponent(CheckBox_SaveKEKKeys))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(Panel_KeyUpdateLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(KEKNonce)
                    .addComponent(Text_Field_KEKNonce, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        TabbedPanel.addTab("Update Keys", Panel_KeyUpdate);

        Button_FWEncrypt.setFont(new java.awt.Font("Arial", 0, 16)); // NOI18N
        Button_FWEncrypt.setForeground(new java.awt.Color(255, 0, 0));
        Button_FWEncrypt.setText("Generate Output File");
        Button_FWEncrypt.setToolTipText("");
        Button_FWEncrypt.setBorder(javax.swing.BorderFactory.createEtchedBorder(new java.awt.Color(255, 0, 0), null));
        Button_FWEncrypt.setEnabled(false);
        Button_FWEncrypt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Button_FWEncryptActionPerformed(evt);
            }
        });

        TextArea_Status.setEditable(false);
        TextArea_Status.setBackground(new java.awt.Color(240, 240, 240));
        TextArea_Status.setColumns(20);
        TextArea_Status.setFont(new java.awt.Font("Arial", 0, 10)); // NOI18N
        TextArea_Status.setLineWrap(true);
        TextArea_Status.setRows(5);
        TextArea_Status.setText("Status:");
        TextArea_Status.setToolTipText("");
        TextArea_Status.setWrapStyleWord(true);
        ScrollPane.setViewportView(TextArea_Status);

        messageLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/ti/msp/gui/images/TI_platform_bar_black_smaller.png"))); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(ScrollPane))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(261, 261, 261)
                        .addComponent(Button_FWEncrypt, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(messageLabel)
                .addContainerGap(31, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(Button_FWEncrypt, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(ScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(messageLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jMenu1.setText("File");
        jMenu1.add(jSeparator1);

        jMenuItem3.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F4, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem3.setText("Exit");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem3);

        jMenuBar1.add(jMenu1);

        jMenu3.setText("Help");

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
        jMenuItem1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/ti/msp/gui/images/Help_icon.png"))); // NOI18N
        jMenuItem1.setText("Help");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem1);
        jMenu3.add(jSeparator2);

        jMenuItem2.setText("About");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem2);

        jMenuBar1.add(jMenu3);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(TabbedPanel)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(TabbedPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 217, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        TabbedPanel.getAccessibleContext().setAccessibleName("EncryptFile");

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        HelpDialog help = new HelpDialog(this, false);
        help.setVisible(true);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        runExitActions();
    }//GEN-LAST:event_formWindowClosing

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        AboutDialog about = new AboutDialog(this, true);
        about.setVisible(true);
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        runExitActions();
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void Button_SearchTITXTActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Button_SearchTITXTActionPerformed
        JFileChooser test = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter(
            "TXT File", "txt");
        test.setFileFilter(filter);
        test.setCurrentDirectory(prevDir);
        int returnVal = test.showOpenDialog(test);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            prevDir = test.getCurrentDirectory();
            File file = test.getSelectedFile();
            TextField_TITXTfile.setText(file.getAbsolutePath());
            try {
                // The name of the file to open.
                TITXTfileName = TextField_TITXTfile.getText();
                TITXTenabled = true;
                Update_GUIComponents();
            } catch (Exception ex) {
                Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            }
        } else {
            System.out.println("File access cancelled by user.");
        }
    }//GEN-LAST:event_Button_SearchTITXTActionPerformed

    private void RadioButton_KeyFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RadioButton_KeyFileActionPerformed
        Update_GUIComponents();
    }//GEN-LAST:event_RadioButton_KeyFileActionPerformed

    private void Button_SearchKeyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Button_SearchKeyActionPerformed
        JFileChooser test = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter(
            "TXT/CSV File", "txt", "csv");
        test.setFileFilter(filter);
        test.setCurrentDirectory(prevDir);
        int returnVal = test.showOpenDialog(test);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            prevDir = test.getCurrentDirectory();
            File file = test.getSelectedFile();
            TextField_Keyfile.setText(file.getAbsolutePath());
            try
            {
                Dkey.GetKeyIVFromFile(TextField_Keyfile.getText());
                TextField_Key.setText(Dkey.KeyFormatted);
                TextField_FWNonce.setText(Dkey.IVFormatted);
                Dkey.isKeyValid = true;
                Dkey.isIVValid = true;
            }
            catch (KeyIV.KeyError| IOException Err)
            {
            }
            
            Update_GUIComponents();
        } else {
            System.out.println("File access cancelled by user.");
        }
    }//GEN-LAST:event_Button_SearchKeyActionPerformed

    class KeyError extends Exception {
       public KeyError(String message) {
         super(message);
       }
    }
    
    String SaveFile(List <String> filelines, String Msg) throws Exception
    {
        if(filelines.get(0).length() > 6 || filelines.get(0).charAt(0) == '@')
        {
            JFileChooser save = new JFileChooser();
            FileNameExtensionFilter filter = new FileNameExtensionFilter(
                "TXT File", "txt");
            save.setFileFilter(filter);
            save.setCurrentDirectory(prevDir);
            save.setDialogTitle(Msg);
            
            int returnVal = save.showSaveDialog(save);

            if (returnVal == JFileChooser.APPROVE_OPTION) {
                prevDir = save.getCurrentDirectory();
                File file = save.getSelectedFile();
                try {
                    if(!file.getAbsolutePath().endsWith(".txt")) Files.write(Paths.get(file.getAbsolutePath().concat(".txt")), filelines);
                    else Files.write(Paths.get(file.getAbsolutePath()), filelines);
                    
                    StatusText = "File successfully saved at " + Paths.get(file.getAbsolutePath());
                    TextArea_Status.setForeground(Color.black);
                    TextArea_Status.append(StatusText + "\n");
                    return file.getAbsolutePath();
                } catch (Exception ex) {
                    throw ex;
                }
            } else {
                //System.out.println("File access cancelled by user.");
                throw new Exception("File access cancelled by user");
            }
        }
        
        throw new Exception("Incorrect format");
    }
    
    final protected static char[] hexArray = "0123456789ABCDEF".toCharArray();
    public static String bytesToHex(byte[] bytes) {
        char[] hexChars = new char[bytes.length * 2];
        for ( int j = 0; j < bytes.length; j++ ) {
            int v = bytes[j] & 0xFF;
            hexChars[j * 2] = hexArray[v >>> 4];
            hexChars[j * 2 + 1] = hexArray[v & 0x0F];
        }
        return new String(hexChars);
    }
    
    byte [] Encryption(byte[] encryptkey, byte[] nonce, byte[] ciphertext) throws IllegalStateException, InvalidCipherTextException
    {
        try {
            int MACsize = 128;
            CCMBlockCipher ccmMode = new CCMBlockCipher(new AESFastEngine());
            ccmMode.init(true, new CCMParameters (new KeyParameter(encryptkey), MACsize, nonce, null));
            byte [] plainBytes = new byte[ccmMode.getOutputSize(ciphertext.length)];
            int res = ccmMode.processBytes(ciphertext, 0, ciphertext.length, plainBytes, 0);
            ccmMode.doFinal(plainBytes, res);
            return plainBytes;

            } catch (IllegalStateException|InvalidCipherTextException ex) {
                Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            } 
        
        return null;
    }
    
    private void RadioButton_KeyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RadioButton_KeyButtonActionPerformed
        Update_GUIComponents();
    }//GEN-LAST:event_RadioButton_KeyButtonActionPerformed

    private void Button_FWEncryptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Button_FWEncryptActionPerformed
        List<String> Filelines = new ArrayList<>();
        
        TextArea_Status.setForeground(Color.black);
        TextArea_Status.setText("Status:\n");
        
        if (CheckBox_GenFile.isSelected() == true)
        {
            Filelines.addAll(GenOutputFile());
        }
        if (CheckBox_UpdateKey.isSelected() == true)
        {
            Filelines.addAll(UpdateKeys());
        }
         
        Filelines.add("q");
        
        try
        {
            SaveFile(Filelines, "Specify the output file");
        } catch(Exception error){
            TextArea_Status.setForeground(Color.red);
            TextArea_Status.append(error.getMessage() + "\n");
        }

        
    }//GEN-LAST:event_Button_FWEncryptActionPerformed

    private List<String> UpdateKeys()
    {
        String NewKeyFileName = null;
        String KEKFileName = null;
        List<String> Encryptedkeylines = null;
                        
        
        try {
                // Update the version of the key
                NewKey.SetVersion(String.format("%2s",Integer.toHexString((Integer) Spinner_NewKeyVersion.getValue())).replace(' ','0'));
                        
                if (ComboBox_NewKeyType.getSelectedIndex() == 0)
                {
                    NewKey.GetKeyIVFromText(TextField_NewKey.getText().toUpperCase(),
                                            KeyIV.typeDEK);
                }
                else if (ComboBox_NewKeyType.getSelectedIndex() == 1)
                {
                    NewKey.GetKeyIVFromText(TextField_NewKey.getText().toUpperCase(),
                                            KeyIV.typeKEK);
                }
                else
                {
                    NewKey.GetKeyIVFromText(TextField_NewKey.getText().toUpperCase(),
                                        KeyIV.typeReserved);
                }
                
                if (RadioButton_NewKeyFile.isSelected() == true)
                {
                    NewKeyFileName = TextField_NewKeyFile.getText();
                }
                else
                {
                    if (CheckBox_SaveNewKey.isSelected() == true)
                    {
                        NewKeyFileName = SaveFile(NewKey.KeyFileLines, "Specify the file to save New Key");
                    }
                }
                
                KEKKey.GetKeyIVFromText(TextField_KEK.getText().toUpperCase(),
                                        Text_Field_KEKNonce.getText(),
                                        KeyIV.typeKEK);

                if (RadioButton_KEKFile.isSelected() == true) 
                {
                    KEKFileName = TextField_NewKeyFile.getText();
                }
                else
                {
                    if (CheckBox_SaveKEKKeys.isSelected() == true)
                    {
                        KEKFileName = SaveFile(KEKKey.KeyFileLines, "Specify the file to save KEK");
                    }
                }
                
                if(NewKey.KeyFileLines.get(0).length() > 6 && KEKKey.KeyFileLines.get(0).length() > 6)
                {
                    byte[] K = Hex.decode(KEKKey.KeyFileLines.get(0).replaceAll("\\s+","").replaceAll(",","").substring(4));
                    byte[] N = Hex.decode(KEKKey.KeyFileLines.get(1).replaceAll("\\s+","").replaceAll(",",""));
                    byte[] P = Hex.decode(NewKey.KeyFileLines.get(0).replaceAll("\\s+","").replaceAll(",",""));
                    
                    byte[] enc = Encryption(K,N,P);

                    if(!Arrays.toString(enc).isEmpty())
                    {
                        Encryptedkeylines = new ArrayList<>();
                        Encryptedkeylines.add("@5000");

                        Encryptedkeylines.add(flags + " " + KEKKey.KeyFileLines.get(1) + " " + counter);
                        String formatIV = KEKKey.KeyFileLines.get(1);
                        int IVlength;
                        
                        formatIV = formatIV.replaceAll("\\s+","").replaceAll(",","").substring(0,22) + 
                                Integer.toHexString(Integer.parseInt(formatIV.replaceAll("\\s+","").replaceAll(",","").substring(22),16)+1);

                        IVlength = formatIV.length();
                        for(int k = 0; k<IVlength/2-1; k++) 
                        {formatIV = formatIV.substring(0,k*3+2) + " " +formatIV.substring(k*3+2, formatIV.length());}   
                        formatIV = formatIV.toUpperCase();

                        int encryptedlength = bytesToHex(enc).length();
                        String formatEncrypted = bytesToHex(enc);
                        for(int i = 0; i<encryptedlength/2-1; i++) 
                        {
                            formatEncrypted = formatEncrypted.substring(0,i*3+2) + " " +formatEncrypted.substring(i*3+2, formatEncrypted.length());
                        }
                        formatEncrypted += " ";
                        formatEncrypted = formatEncrypted.toUpperCase();
                        for(int i = 0; i<= encryptedlength/32-1; i++) 
                        {
                            Encryptedkeylines.add(formatEncrypted.substring(i*48,i*48+48));
                        }
                        Encryptedkeylines.add(formatEncrypted.substring(encryptedlength/32*48));
                        //Encryptedkeylines.add("q");

                        StatusText = "Key encryption complete!" + "\n" + "The new  nonce is " + formatIV;
                        Text_Field_KEKNonce.setText(formatIV);
                        TextArea_Status.setForeground(Color.black);
                        TextArea_Status.append(StatusText + "\n");

                        //SaveFile(Encryptedkeylines, "Specify an encryption file to save");
                        
                        if (KEKFileName != null)
                        {
                            KEKKey.KeyFileLines.set(1, formatIV); 
                            if(!KEKFileName.endsWith(".txt")) 
                            {
                                Files.write(Paths.get(KEKFileName.concat(".txt")), KEKKey.KeyFileLines);
                            }
                            else 
                            {
                                Files.write(Paths.get(KEKFileName), KEKKey.KeyFileLines);
                            }
                            StatusText = "KEK file under " + KEKFileName + " has been updated appropriately";
                            TextArea_Status.setForeground(Color.black);
                            TextArea_Status.append(StatusText + "\n");                            
                        }
                        if (NewKeyFileName != null)
                        {
                            NewKey.KeyFileLines.set(1, formatIV); 
                            if(!NewKeyFileName.endsWith(".txt")) 
                            {
                                Files.write(Paths.get(NewKeyFileName.concat(".txt")), NewKey.KeyFileLines);
                            }
                            else 
                            {
                                Files.write(Paths.get(NewKeyFileName), NewKey.KeyFileLines);
                            }
                            StatusText = "New Key file under " + NewKeyFileName + " has been updated appropriately";
                            TextArea_Status.setForeground(Color.black);
                            TextArea_Status.append(StatusText + "\n");                            
                        }
                    }
                }
            } catch (IOException|IllegalStateException|InvalidCipherTextException ex) {
              Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch(KeyError error){
            TextArea_Status.setForeground(Color.red);
            TextArea_Status.append(error.getMessage() + "\n");
        }
        catch(Exception error){
            TextArea_Status.setForeground(Color.red);
            TextArea_Status.append(error.getMessage() + "\n");
        }
        
        Update_GUIComponents();
        return Encryptedkeylines;

    }
    
    private List<String> GenOutputFile()
    {
        List<String> TITXTfilelines;
        String KeyFileName  = null;
        List<String> Encryptedkeylines = null;
        
        try {
            TITXTfilelines = Files.readAllLines(Paths.get(TITXTfileName));
            if(TITXTfilelines.get(0).charAt(0) != '@')
            {
                TextArea_Status.setForeground(Color.red);
                TextArea_Status.append("TI TXT file format is incorrect\n");
            }
            
            Dkey.GetKeyIVFromText(TextField_Key.getText().toUpperCase(),
                                     TextField_FWNonce.getText().toUpperCase(),
                                     KeyIV.typeDEK);

            if (RadioButton_KeyFile.isSelected() == true)
            {
                KeyFileName = TextField_Keyfile.getText();
            }
            else
            {
                if (CheckBox_SaveKey.isSelected() == true)
                {
                    KeyFileName = SaveFile(Dkey.KeyFileLines, "Specify a file to save Data Encryption Key");
                }
            }
            
            //ENCRYPTION CODE GOES HERE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            if(Dkey.KeyFileLines.get(0).length() > 6 && TITXTfilelines.get(0).charAt(0) == '@')
            {
                int numberaddresses = 0;
                for(int i = 0; i<TITXTfilelines.size(); i++) 
                {
                    if(TITXTfilelines.get(i).charAt(0) == '@') 
                    {
                        numberaddresses++;
                    }
                }
                String[] address = new String [numberaddresses];
                int[] addressline = new int [numberaddresses];
                int datainfo[] = new int[numberaddresses];
                String[] data = new String[numberaddresses];
                int qline = 0;
                numberaddresses = 0;
                for(int i = 0; i<TITXTfilelines.size(); i++)
                {
                    if(TITXTfilelines.get(i).charAt(0) == '@')
                    {
                        address[numberaddresses] = TITXTfilelines.get(i).substring(1);
                        addressline[numberaddresses] = i;
                        numberaddresses++;
                    }
                    else if (TITXTfilelines.get(i).charAt(0) == 'q') 
                    {
                        qline = i;
                    }
                }

                for(int i = 0; i<numberaddresses-1; i++)
                {
                    data[i] = "";
                    for(int j = 0; j<addressline[i+1]-addressline[i]-1; j++)
                    {
                        datainfo[i] += TITXTfilelines.get(addressline[i]+1+j).replaceAll("\\s+","").length()/2;
                        data[i] += TITXTfilelines.get(addressline[i]+1+j).replaceAll("\\s+","");
                    }
                }
                data[numberaddresses-1] = "";
                for(int j = 0; j<qline-addressline[numberaddresses-1]-1; j++)
                {
                    datainfo[numberaddresses-1] += TITXTfilelines.get(addressline[numberaddresses-1]+1+j).replaceAll("\\s+","").length()/2;
                    data[numberaddresses-1] += TITXTfilelines.get(addressline[numberaddresses-1]+1+j).replaceAll("\\s+","");
                }

                for(int i = 0; i<numberaddresses; i++)
                {
                    System.out.println(address[i] + " at line " + addressline[i]);
                    System.out.println(datainfo[i] + " data bytes in space");
                    System.out.println("data: " + data[i]);
                }
                System.out.println("q at line " + qline + "\n");
                Encryptedkeylines = new ArrayList<>();

                byte[] K = Hex.decode(Dkey.KeyFileLines.get(0).replaceAll("\\s+","").replaceAll(",","").substring(4));
                byte[] N = Hex.decode(Dkey.KeyFileLines.get(1).replaceAll("\\s+","").replaceAll(",",""));
                String formatIV = Dkey.KeyFileLines.get(1);
                int IVlength;
                int numpackets = 0;
                int thispacket = 1;
                String formatEncrypted;
                int encryptedlength;
                String encryptpacket;
                String currentaddress;

                for(int i = 0; i<numberaddresses; i++)
                {
                    for(int j = 0; j<datainfo[i]/packetsize; j++) 
                    {
                        numpackets++;
                    }
                    if (!data[i].substring((datainfo[i]/packetsize)*packetsize*2).isEmpty()) 
                    {
                        numpackets++;
                    }
                }

                for(int i = 0; i<numberaddresses; i++)
                {
                    currentaddress = address[i];
                    for(int j = 0; j<datainfo[i]/packetsize+1; j++)
                    {
                        if(!(j == datainfo[i]/packetsize && data[i].substring((datainfo[i]/packetsize)*packetsize*2).isEmpty()))
                        {
                            Encryptedkeylines.add("@A000");
                            Encryptedkeylines.add(flags + " " + formatIV + " " + counter);
                            if(j<datainfo[i]/packetsize)
                            {
                                encryptpacket = String.format("%2s",Integer.toHexString((Integer) Spinner_AppVersion.getValue())).replace(' ','0') + 
                                String.format("%4s",Integer.toHexString(thispacket)).replace(' ','0') +
                                String.format("%4s",Integer.toHexString(numpackets)).replace(' ','0') + reserved +
                                String.format("%6s",currentaddress).replace(' ','0').substring(4) +
                                String.format("%6s",currentaddress).replace(' ','0').substring(2,4) +
                                String.format("%6s",currentaddress).replace(' ','0').substring(0,2) +
                                data[i].substring(j*packetsize*2, j*packetsize*2+packetsize*2);
                                currentaddress = String.format("%4s",Integer.toHexString(Integer.parseInt(currentaddress,16)+packetsize)).replace(' ','0');
                            }
                            else
                            {
                                encryptpacket = String.format("%2s",Integer.toHexString((Integer) Spinner_AppVersion.getValue())).replace(' ','0') + 
                                String.format("%4s",Integer.toHexString(thispacket)).replace(' ','0') +
                                String.format("%4s",Integer.toHexString(numpackets)).replace(' ','0') + reserved +
                                String.format("%6s",currentaddress).replace(' ','0').substring(4) +
                                String.format("%6s",currentaddress).replace(' ','0').substring(2,4) +
                                String.format("%6s",currentaddress).replace(' ','0').substring(0,2) +
                                data[i].substring((datainfo[i]/packetsize)*packetsize*2);
                            }
                            thispacket++;

                            System.out.println(encryptpacket);

                            byte[] P = Hex.decode(encryptpacket);
                            byte [] enc = Encryption(K,N,P);

                            N = Hex.decode(bytesToHex(N).substring(0,22) +
                                Integer.toHexString(Integer.parseInt(bytesToHex(N).substring(22),16)+1));

                            formatIV = formatIV.replaceAll("\\s+","").replaceAll(",","").substring(0,22) +
                            Integer.toHexString(Integer.parseInt(formatIV.replaceAll("\\s+","").replaceAll(",","").substring(22),16)+1);

                            IVlength = formatIV.length();
                            for(int k = 0; k<IVlength/2-1; k++)
                            {
                                formatIV = formatIV.substring(0,k*3+2) + " " +formatIV.substring(k*3+2, formatIV.length());
                            }
                            formatIV = formatIV.toUpperCase();

                            formatEncrypted = bytesToHex(enc);
                            encryptedlength = bytesToHex(enc).length();
                            for(int k = 0; k<encryptedlength/2-1; k++)
                            {
                                formatEncrypted = formatEncrypted.substring(0,k*3+2) + " " +
                                formatEncrypted.substring(k*3+2, formatEncrypted.length());
                            }
                            formatEncrypted += " ";
                            formatEncrypted = formatEncrypted.toUpperCase();
                            for(int k = 0; k<= encryptedlength/32-1; k++) Encryptedkeylines.add(formatEncrypted.substring(k*48,k*48+48));
                            if(!formatEncrypted.substring(encryptedlength/32*48).isEmpty())
                            {
                                Encryptedkeylines.add(formatEncrypted.substring(encryptedlength/32*48));
                            }
                        }
                    }
                }

                TextArea_Status.append("Encryption of file complete  ...\n");
                //SaveFile(Encryptedkeylines, "Specify the output file");
                
                StatusText = "Encryption of " + Paths.get(TITXTfileName) +  " is complete!" + "\n" + "The new  nonce is " + formatIV;
                TextField_FWNonce.setText(formatIV);
                TextArea_Status.setForeground(Color.black);
                TextArea_Status.append(StatusText + "\n");
                Dkey.KeyFileLines.set(1, formatIV);
                
                if (KeyFileName != null)
                {
                    if(!KeyFileName.endsWith(".txt")) 
                    {
                        Files.write(Paths.get(KeyFileName.concat(".txt")), Dkey.KeyFileLines);
                    }
                    else 
                    {
                        Files.write(Paths.get(KeyFileName), Dkey.KeyFileLines);
                    }
                    StatusText = "Key file under  " + KeyFileName + " has been updated appropriately";
                    TextArea_Status.setForeground(Color.black);
                    TextArea_Status.append(StatusText + "\n");
                }
            }
        } catch (IOException|IllegalStateException|InvalidCipherTextException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch(KeyError error){
            StatusText = error.getMessage();
            TextArea_Status.setForeground(Color.red);
            TextArea_Status.append(StatusText + "\n");
            Update_GUIComponents();
        }
        catch(Exception error){
            StatusText = error.getMessage();
            TextArea_Status.setForeground(Color.red);
            TextArea_Status.append(StatusText + "\n");
        }
        
        Update_GUIComponents();
        return Encryptedkeylines;
    }
    
    
    public List<String> UpdateGUI_KeyIV(KeyIV key_IV, 
                                javax.swing.JRadioButton RadioButtonSelect,
                                javax.swing.JButton ButtonSearchFile,
                                javax.swing.JCheckBox CheckBoxSaveFile,
                                javax.swing.JTextField TextField_FileName,
                                javax.swing.JTextField TextField_Key,
                                javax.swing.JTextField TextField_IV)
    {
        List<String> ErrorList = new ArrayList<String>();
        
        // Use text boxes for Key and IV
        if (RadioButtonSelect.isSelected() == false)
        {
            TextField_Key.setEnabled(true);
            TextField_IV.setEnabled(true);
            TextField_FileName.setEnabled(false);
            TextField_FileName.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            ButtonSearchFile.setEnabled(false);
            CheckBoxSaveFile.setEnabled(true);
            if (key_IV.isKeyValid == false) 
            {
                TextField_Key.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(255, 0, 0)));
                ErrorList.add("Key is Invalid");
            }
            else
            {
                TextField_Key.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            }
            
            if (key_IV.isIVValid == false) 
            {
                TextField_IV.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(255, 0, 0)));
                ErrorList.add("IV is invalid");
            }
            else
            {
                TextField_IV.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            }
        }
        else
        {
            TextField_Key.setEnabled(false);
            TextField_IV.setEnabled(false);
            TextField_IV.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            TextField_Key.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            
            TextField_FileName.setEnabled(true);
            if (key_IV.isFileSelected == true )
            {
                TextField_FileName.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            }
            else
            {
                TextField_FileName.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(255, 0, 0)));
                ErrorList.add("File is Invalid");
            }
            ButtonSearchFile.setEnabled(true);
            CheckBoxSaveFile.setEnabled(false);
        }
        
        return ErrorList;
    }
    
    public List<String> UpdateGUI_KeyIV(KeyIV key_IV, 
                                javax.swing.JRadioButton RadioButtonSelect,
                                javax.swing.JButton ButtonSearchFile,
                                javax.swing.JCheckBox CheckBoxSaveFile,
                                javax.swing.JTextField TextField_FileName,
                                javax.swing.JTextField TextField_Key)
    {
        List<String> ErrorList = new ArrayList<String>();
        
        // Use text boxes for Key and IV
        if (RadioButtonSelect.isSelected() == false)
        {
            TextField_Key.setEnabled(true);
            TextField_FileName.setEnabled(false);
            TextField_FileName.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            ButtonSearchFile.setEnabled(false);
            CheckBoxSaveFile.setEnabled(true);
            if (key_IV.isKeyValid == false) 
            {
                TextField_Key.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(255, 0, 0)));
                ErrorList.add("Key is Invalid");
            }
            else
            {
                TextField_Key.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            }
        }
        else
        {
            TextField_Key.setEnabled(false);
            TextField_Key.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            
            TextField_FileName.setEnabled(true);
            if (key_IV.isFileSelected == true )
            {
                TextField_FileName.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            }
            else
            {
                TextField_FileName.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(255, 0, 0)));
                ErrorList.add("File is Invalid");
            }
            ButtonSearchFile.setEnabled(true);
            CheckBoxSaveFile.setEnabled(false);
        }
        
        return ErrorList;
    }
    
    private void Update_GUIComponents()
    {
        boolean UpdateKeyOK = true;
        boolean GenFileOK = true;
        String text_button = "<html>";
        
        // Update Encrypt File Panel
        if (CheckBox_GenFile.isSelected()== true)
        {
            // Enable input .txt 
            Button_SearchTITXT.setEnabled(true);
            TextField_TITXTfile.setEnabled(true);
            if (TITXTenabled == true )
            {
                TextField_TITXTfile.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            }
            else
            {
                TextField_TITXTfile.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(255, 0, 0)));
                text_button += "<font color=\"red\">Select an input .txt file </font><br>";
            }

            List<String> ErrorList = UpdateGUI_KeyIV(Dkey,
                                                    RadioButton_KeyFile,
                                                    Button_SearchKey,
                                                    CheckBox_SaveKey,
                                                    TextField_Keyfile,
                                                    TextField_Key,
                                                    TextField_FWNonce);
        
            for (int i=0; i < ErrorList.size(); i++)
            {
                text_button += "<font color=\"red\">Data Key " + ErrorList.get(i) +"</font><br>";
            }
            
            // Check if there's an error in this tab
            if ( (TITXTenabled == true)&& 
               (Dkey.isKeyValid == true) && 
               (Dkey.isIVValid == true) && 
               ((RadioButton_KeyFile.isSelected() == false) || (Dkey.isFileSelected == true)))
            {
                TabbedPanel.setTitleAt(0, "<html><font color='black'>Encrypt File</font></html>");
            }
            else
            {
                TabbedPanel.setTitleAt(0, "<html><font color='red'>Encrypt File</font></html>");
            }

            // check if the button to generate output should be enabled for this tab
            if ( (TITXTenabled == false ) ||
                 ((RadioButton_KeyFile.isSelected() == true) && (Dkey.isFileSelected == false)) )
            {
                GenFileOK = false;
            }
            
            Spinner_AppVersion.setEnabled(true);
                
        }
        else
        {
            TextField_FWNonce.setEnabled(false);
            TextField_Key.setEnabled(false);
            TextField_Keyfile.setEnabled(false);
            TextField_TITXTfile.setEnabled(false);
            Button_SearchKey.setEnabled(false);
            Button_SearchTITXT.setEnabled(false);
            TextField_TITXTfile.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            TextField_Keyfile.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            Button_FWEncrypt.setEnabled(false);
            CheckBox_SaveKey.setEnabled(false);
            TabbedPanel.setTitleAt(0, "<html><font color='black'>Encrypt File</font></html>");
            Spinner_AppVersion.setEnabled(false);
            GenFileOK = true;
        }
        
         
        
        //
        // Update Update Key Panel
        ///
        if (CheckBox_UpdateKey.isSelected() == true)
        {
            ComboBox_NewKeyType.setEnabled(true); 
            
            List<String> ErrorList = UpdateGUI_KeyIV(NewKey,
                                                    RadioButton_NewKeyFile,
                                                    Button_FileNewKey,
                                                    CheckBox_SaveNewKey,
                                                    TextField_NewKeyFile,
                                                    TextField_NewKey);
        
            if (RadioButton_NewKeyFile.isSelected() == true)
            {
                Spinner_NewKeyVersion.setEnabled(false);
                ComboBox_NewKeyType.setEnabled(false);
            }
            else
            {
                Spinner_NewKeyVersion.setEnabled(true);
                ComboBox_NewKeyType.setEnabled(true);
            }
            for (int i=0; i < ErrorList.size(); i++)
            {
                text_button += "<font color=\"red\">New Key " + ErrorList.get(i) +"</font><br>";
            }
            
            ErrorList = UpdateGUI_KeyIV(KEKKey,
                                        RadioButton_KEKFile,
                                        Button_FileKEK,
                                        CheckBox_SaveKEKKeys,
                                        TextField_KEKFile,
                                        TextField_KEK,
                                        Text_Field_KEKNonce);
        
            for (int i=0; i < ErrorList.size(); i++)
            {
                text_button += "<font color=\"red\">KEK " + ErrorList.get(i) +"</font><br>";
            }
            
            // Check if there's an error in this tab
            if ( (NewKey.isKeyValid == true) && 
               (KEKKey.isKeyValid == true) && 
               (KEKKey.isIVValid == true) &&
               ((RadioButton_NewKeyFile.isSelected() == false) || (NewKey.isFileSelected == true)) && 
               ((RadioButton_KEKFile.isSelected() == false) || (KEKKey.isFileSelected == true)))
            {
                TabbedPanel.setTitleAt(1, "<html><font color='black'>Update Keys</font></html>");
            }
            else
            {
                TabbedPanel.setTitleAt(1, "<html><font color='red'>Update Keys</font></html>");
            }

            // check if the button to generate output should be enabled for this tab
            if ( ((RadioButton_NewKeyFile.isSelected() == true) && (NewKey.isFileSelected == false)) ||
                 ((RadioButton_KEKFile.isSelected() == true) && (KEKKey.isFileSelected == false))  )
            {
                UpdateKeyOK = false;
            }
        }
        else
        {
            UpdateKeyOK = true;
            TextField_KEK.setEnabled(false);
            TextField_KEKFile.setEnabled(false);
            TextField_KEKFile.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            TextField_NewKey.setEnabled(false);
            TextField_NewKeyFile.setEnabled(false);
            TextField_NewKeyFile.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(240, 240, 240)));
            Text_Field_KEKNonce.setEnabled(false);
            Button_FileNewKey.setEnabled(false);
            Button_FileKEK.setEnabled(false);
            ComboBox_NewKeyType.setEnabled(false);
            Spinner_NewKeyVersion.setEnabled(false);
        }
        
         
        
        //
        // Check if we can generate an Output file
        //
        if ( (CheckBox_GenFile.isSelected()== false ) &&
             (CheckBox_UpdateKey.isSelected() == false) )
        {
            // At least one of the checkboxes must be enabled
            text_button += "<font color=\"red\">Enable File Encryption or Key Update</font><br>";
            UpdateKeyOK = false;
            GenFileOK = false;
        }
        
        if ((UpdateKeyOK == true) && (GenFileOK == true))
        {
            Button_FWEncrypt.setEnabled(true);
            text_button += "Press to generate encrypted output file </html>";
            Button_FWEncrypt.setToolTipText(text_button);
            Button_FWEncrypt.setForeground(new java.awt.Color(0, 0, 0));
            Button_FWEncrypt.setBorder(javax.swing.BorderFactory.createEtchedBorder(new java.awt.Color(240, 240, 240), null));
        }
        else
        {
            Button_FWEncrypt.setEnabled(false);
            text_button += "</html>";
            Button_FWEncrypt.setToolTipText(text_button);
            Button_FWEncrypt.setForeground(new java.awt.Color(255, 0, 0));
            Button_FWEncrypt.setBorder(javax.swing.BorderFactory.createEtchedBorder(new java.awt.Color(255, 0, 0), null));
        }
    }
    
    private void CheckBox_GenFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CheckBox_GenFileActionPerformed
        Update_GUIComponents();
    }//GEN-LAST:event_CheckBox_GenFileActionPerformed

    private void TextField_KeyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TextField_KeyActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_TextField_KeyActionPerformed

    private void Button_FileNewKeyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Button_FileNewKeyActionPerformed
        JFileChooser load = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter(
            "TXT/CSV File", "txt", "csv");
        load.setFileFilter(filter);
        load.setCurrentDirectory(prevDir);
        int returnVal = load.showOpenDialog(load);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            prevDir = load.getCurrentDirectory();
            File file = load.getSelectedFile();
            TextField_NewKeyFile.setText(file.getAbsolutePath());
            try {
                NewKey.GetKeyIVFromFile(TextField_NewKeyFile.getText());
                if (NewKey.Type.equals(KeyIV.typeDEK))
                {
                    ComboBox_NewKeyType.setSelectedIndex(0);
                }
                else if (NewKey.Type.equals(KeyIV.typeKEK))
                {
                    ComboBox_NewKeyType.setSelectedIndex(1);
                }
                else
                {   // Reserved type
                    ComboBox_NewKeyType.setSelectedIndex(2);
                }
                TextField_NewKey.setText(NewKey.KeyFormatted);
                Spinner_NewKeyVersion.setValue(Integer.parseInt(NewKey.Version, 16));
                NewKey.isKeyValid = true;
            }
            catch (KeyIV.KeyError| IOException Err)
            {
            }
            Update_GUIComponents();
        } else {
            System.out.println("File access cancelled by user.");
        }
    }//GEN-LAST:event_Button_FileNewKeyActionPerformed

    private void Button_FileKEKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Button_FileKEKActionPerformed
        JFileChooser load = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter(
            "TXT/CSV File", "txt", "csv");
        load.setFileFilter(filter);
        load.setCurrentDirectory(prevDir);
        int returnVal = load.showOpenDialog(load);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            prevDir = load.getCurrentDirectory();
            File file = load.getSelectedFile();
            TextField_KEKFile.setText(file.getAbsolutePath());
            try {
                KEKKey.GetKeyIVFromFile(TextField_KEKFile.getText(), KeyIV.typeKEK);
                TextField_KEK.setText(KEKKey.KeyFormatted);
                Text_Field_KEKNonce.setText(KEKKey.IVFormatted);
                KEKKey.isKeyValid = true;
                KEKKey.isIVValid = true;
            }
            catch (KeyIV.KeyError| IOException Err)
            {
            }
            Update_GUIComponents();
        } else {
            System.out.println("File access cancelled by user.");
        }
    }//GEN-LAST:event_Button_FileKEKActionPerformed

    private void RadioButton_KEKFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RadioButton_KEKFileActionPerformed
        Update_GUIComponents();
    }//GEN-LAST:event_RadioButton_KEKFileActionPerformed

    private void RadioButton_KEKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RadioButton_KEKActionPerformed
        Update_GUIComponents();
    }//GEN-LAST:event_RadioButton_KEKActionPerformed

    private void TextField_NewKeyFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TextField_NewKeyFileActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_TextField_NewKeyFileActionPerformed

    private void CheckBox_UpdateKeyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CheckBox_UpdateKeyActionPerformed
        Update_GUIComponents();
    }//GEN-LAST:event_CheckBox_UpdateKeyActionPerformed

    private void RadioButton_NewKeyFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RadioButton_NewKeyFileActionPerformed
        Update_GUIComponents();
    }//GEN-LAST:event_RadioButton_NewKeyFileActionPerformed

    private void RadioButton_NewKeyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RadioButton_NewKeyActionPerformed
        Update_GUIComponents();
    }//GEN-LAST:event_RadioButton_NewKeyActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup ButtonGroup_NewKey;
    private javax.swing.ButtonGroup ButtonGroup_UpdateFW;
    private javax.swing.ButtonGroup ButtonGroup_UpdateKEK;
    private javax.swing.JButton Button_FWEncrypt;
    private javax.swing.JButton Button_FileKEK;
    private javax.swing.JButton Button_FileNewKey;
    private javax.swing.JButton Button_SearchKey;
    private javax.swing.JButton Button_SearchTITXT;
    private javax.swing.JCheckBox CheckBox_GenFile;
    private javax.swing.JCheckBox CheckBox_SaveKEKKeys;
    private javax.swing.JCheckBox CheckBox_SaveKey;
    private javax.swing.JCheckBox CheckBox_SaveNewKey;
    private javax.swing.JCheckBox CheckBox_UpdateKey;
    private javax.swing.JComboBox ComboBox_NewKeyType;
    private javax.swing.JLabel FWKeyNonce;
    private javax.swing.JLabel KEKNonce;
    private javax.swing.JPanel Panel_EncryptFile;
    private javax.swing.JPanel Panel_KeyUpdate;
    private javax.swing.JRadioButton RadioButton_KEK;
    private javax.swing.JRadioButton RadioButton_KEKFile;
    private javax.swing.JRadioButton RadioButton_KeyButton;
    private javax.swing.JRadioButton RadioButton_KeyFile;
    private javax.swing.JRadioButton RadioButton_NewKey;
    private javax.swing.JRadioButton RadioButton_NewKeyFile;
    private javax.swing.JScrollPane ScrollPane;
    private javax.swing.JSpinner Spinner_AppVersion;
    private javax.swing.JSpinner Spinner_NewKeyVersion;
    private javax.swing.JLabel TITXT;
    private javax.swing.JLabel TITXT1;
    private javax.swing.JLabel TITXT2;
    private javax.swing.JTabbedPane TabbedPanel;
    private javax.swing.JTextArea TextArea_Status;
    private javax.swing.JTextField TextField_FWNonce;
    private javax.swing.JTextField TextField_KEK;
    private javax.swing.JTextField TextField_KEKFile;
    private javax.swing.JTextField TextField_Key;
    private javax.swing.JTextField TextField_Keyfile;
    private javax.swing.JTextField TextField_NewKey;
    private javax.swing.JTextField TextField_NewKeyFile;
    private javax.swing.JTextField TextField_TITXTfile;
    private javax.swing.JTextField Text_Field_KEKNonce;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JLabel messageLabel;
    // End of variables declaration//GEN-END:variables


    private void runExitActions() {
        Object[] options = {"Yes","No"};
        
        int n = JOptionPane.showOptionDialog(this, 
            "Are you sure you want to exit?", 
            Main.APLICATION_NAME, 
            JOptionPane.YES_NO_OPTION, 
            JOptionPane.QUESTION_MESSAGE,
            null,
            options,
            options[1]);

        if(n == JOptionPane.YES_OPTION){
            StaticInfo.debug("Exiting Application");
            System.exit(0);
        }
    }

    private void updateMessageLabel(String string) {
        messageLabel.setText("");
        messageLabel.setText(string);
    }
   
        
}
